public class MyLinkedList<E> implements List<E> {

	private class Link {
		private E elt;
		private Link next = null;
		//Constructor
		private Link(E e) {
			elt = e;
		}
	}

	private Link first = null;
	private Link last;
	private int size;

	public MyLinkedList() {
		size = 0;
  }
	public int size(){return size;}

	public void add(E e) {
		Link newLink = new Link(e);
		if(first == null){
			first = newLink;
			last = newLink;
		}
		else {
			last.next = newLink;
			last = newLink;
		}
		size++;
	}

	public E get(int index) {
		if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }
		Link cur = first;
		while(index > 0){
			cur = cur.next;
			index--;
		}
		return cur.elt;
	}

	public void remove(int index) {
	  // antar att index är tillåten (>= 0 , < size)
		if (index < 0 || index >= size) {
      throw new IndexOutOfBoundsException();
    }
		if(index == 0){
			first = first.next;
		}
		else{
			Link cur = first;
			Link prev = null;
			while (index > 0){
				prev = cur;
				cur = cur.next;
				index--;
			}
			prev.next = cur.next;
			if (cur.next == null){
				last = prev;
			}
		}
		size--;
	}
}
